import 'package:hive/hive.dart';
part 'config_data.g.dart';

@HiveType(typeId: 0)
class configData extends HiveObject {
  @HiveField(0)
  String? apiUrl;
  @HiveField(1)
  String? gatewayApiUrl;
  @HiveField(2)
  String? gatewayApiKey;
  @HiveField(3)
  String? supportUrl;
  @HiveField(4)
  String? stores;
  @HiveField(5)
  String? products;
  @HiveField(6)
  List<Countries>? countries;
  @HiveField(7)
  String? googleMapsApiKey;
  @HiveField(8)
  List<Payment_Methods?>? payment_methods;

  configData(
      {this.apiUrl,
      this.gatewayApiUrl,
      this.gatewayApiKey,
      this.supportUrl,
      this.stores,
      this.products,
      this.countries,
      this.googleMapsApiKey,
      this.payment_methods});

  configData.fromJson(Map<String, dynamic> json) {
    apiUrl = json['api_url'];
    gatewayApiUrl = json['gateway_api_url'];
    gatewayApiKey = json['gateway_api_key'];
    supportUrl = json['support_url'];
    stores = json['stores'];
    products = json['products'];
    if (json['countries'] != null) {
      countries = <Countries>[];
      json['countries'].forEach((v) {
        countries?.add(new Countries.fromJson(v));
      });
    }
    googleMapsApiKey = json['google_maps_api_key'];

    if (json['payment_methods'] != null) {
      final v = json['payment_methods'];
      final arr0 = <Payment_Methods>[];
      v.forEach((v) {
        arr0.add(Payment_Methods.fromJson(v));
      });
      payment_methods = arr0;
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['api_url'] = this.apiUrl;
    data['gateway_api_url'] = this.gatewayApiUrl;
    data['gateway_api_key'] = this.gatewayApiKey;
    data['support_url'] = this.supportUrl;
    data['stores'] = this.stores;
    data['products'] = this.products;
    if (this.countries != null) {
      data['countries'] = this.countries!.map((v) => v.toJson()).toList();
    }
    data['google_maps_api_key'] = this.googleMapsApiKey;

    if (payment_methods != null) {
      final v = payment_methods;
      final arr0 = [];
      v!.forEach((v) {
        arr0.add(v!.toJson());
      });
      data['payment_methods'] = arr0;
    }
    return data;
  }
}

@HiveType(typeId: 1)
class Countries {
  @HiveField(0)
  String? name;
  @HiveField(1)
  String? value;
  @HiveField(2)
  List<States>? states;

  Countries({this.name, this.value, this.states});

  Countries.fromJson(Map<String, dynamic> json) {
    name = json['name'];
    value = json['value'];
    if (json['states'] != null) {
      states = <States>[];
      json['states'].forEach((v) {
        states!.add(new States.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['name'] = this.name;
    data['value'] = this.value;
    if (this.states != null) {
      data['states'] = this.states!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

@HiveType(typeId: 2)
class States {
  @HiveField(0)
  String? name;
  @HiveField(1)
  String? value;
  @HiveField(2)
  List<Cities>? cities;

  States({this.name, this.value, this.cities});

  States.fromJson(Map<String, dynamic> json) {
    name = json['name'];
    value = json['value'];
    if (json['cities'] != null) {
      cities = <Cities>[];
      json['cities'].forEach((v) {
        cities!.add(new Cities.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['name'] = this.name;
    data['value'] = this.value;
    if (this.cities != null) {
      data['cities'] = this.cities!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

@HiveType(typeId: 3)
class Cities {
  @HiveField(0)
  String? name;
  @HiveField(1)
  String? value;

  @HiveField(2)
  int? zip;
  @HiveField(3)
  List<String>? neighborhood;

  Cities({this.name, this.value, this.zip, this.neighborhood});

  Cities.fromJson(Map<String, dynamic> json) {
    name = json['name'];
    value = json['value'];
    zip = json['zip'];
    neighborhood = json['neighborhood'].cast<String>();
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['name'] = this.name;
    data['value'] = this.value;
    data['zip'] = this.zip;
    data['neighborhood'] = this.neighborhood;
    return data;
  }
}

@HiveType(typeId: 4)
class Payment_Methods {
  @HiveField(0)
  String? name;
  @HiveField(1)
  String? method;
  @HiveField(2)
  bool? is_enabled;
  @HiveField(3)
  String? public_key;
  @HiveField(4)
  String? private_key;
  @HiveField(5)
  String? api_url;

  Payment_Methods(
      {this.name,
      this.method,
      this.is_enabled,
      this.public_key,
      this.private_key,
      this.api_url});
  Payment_Methods.fromJson(Map<String, dynamic> json) {
    name = json['name']?.toString();
    method = json['method']?.toString();
    is_enabled = json['is_enabled'];
    public_key = json['public_key']?.toString();
    private_key = json['private_key']?.toString();
    api_url = json['api_url']?.toString();
  }
  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    data['name'] = name;
    data['method'] = method;
    data['is_enabled'] = is_enabled;
    data['public_key'] = public_key;
    data['private_key'] = private_key;
    data['api_url'] = api_url;

    return data;
  }
}
