import 'package:hive/hive.dart';
part 'self_data.g.dart';

@HiveType(typeId: 5)
class SelfData extends HiveObject {
  @HiveField(0)
  String? id;
  @HiveField(1)
  String? name;
  @HiveField(2)
  String? namespace;
  @HiveField(3)
  String? type;
  @HiveField(4)
  String? icon;
  @HiveField(5)
  String? short_description;
  @HiveField(6)
  String? terms_of_service;
  @HiveField(7)
  String? privacy_policy;
  @HiveField(8)
  String? company_name;
  @HiveField(9)
  String? support_email;
  @HiveField(10)
  String? support_phone;
  @HiveField(11)
  String? support_website;
  @HiveField(12)
  String? website;
  @HiveField(13)
  String? street;
  @HiveField(14)
  String? city;
  @HiveField(15)
  String? state;
  @HiveField(16)
  String? zip;
  @HiveField(17)
  String? country;
  @HiveField(18)
  SelfDataAllowed_locations? allowed_locations;
  @HiveField(19)
  String? gateway_api_url;

  SelfData({
    this.id,
    this.name,
    this.namespace,
    this.type,
    this.icon,
    this.short_description,
    this.terms_of_service,
    this.privacy_policy,
    this.company_name,
    this.support_email,
    this.support_phone,
    this.support_website,
    this.website,
    this.street,
    this.city,
    this.state,
    this.zip,
    this.country,
    this.allowed_locations,
    this.gateway_api_url,
  });
  SelfData.fromJson(Map<String, dynamic> json) {
    id = json['id']?.toString();
    name = json['name']?.toString();
    namespace = json['namespace']?.toString();
    type = json['type']?.toString();
    icon = json['icon']?.toString();
    short_description = json['short_description']?.toString();
    terms_of_service = json['terms_of_service']?.toString();
    privacy_policy = json['privacy_policy']?.toString();
    company_name = json['company_name']?.toString();
    support_email = json['support_email']?.toString();
    support_phone = json['support_phone']?.toString();
    support_website = json['support_website']?.toString();
    website = json['website']?.toString();
    street = json['street']?.toString();
    city = json['city']?.toString();
    state = json['state']?.toString();
    zip = json['zip']?.toString();
    country = json['country']?.toString();
    allowed_locations = (json['allowed_locations'] != null)
        ? SelfDataAllowed_locations.fromJson(json['allowed_locations'])
        : null;
    gateway_api_url = json['gateway_api_url']?.toString();
  }
  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    data['id'] = id;
    data['name'] = name;
    data['namespace'] = namespace;
    data['type'] = type;
    data['icon'] = icon;
    data['short_description'] = short_description;
    data['terms_of_service'] = terms_of_service;
    data['privacy_policy'] = privacy_policy;
    data['company_name'] = company_name;
    data['support_email'] = support_email;
    data['support_phone'] = support_phone;
    data['support_website'] = support_website;
    data['website'] = website;
    data['street'] = street;
    data['city'] = city;
    data['state'] = state;
    data['zip'] = zip;
    data['country'] = country;
    if (allowed_locations != null) {
      data['allowed_locations'] = allowed_locations!.toJson();
    }
    data['gateway_api_url'] = gateway_api_url;
    return data;
  }
}

@HiveType(typeId: 6)
class SelfDataAllowed_locations {
  @HiveField(0)
  List<String?>? PK;
  @HiveField(1)
  SelfDataAllowed_locations({
    this.PK,
  });
  SelfDataAllowed_locations.fromJson(Map<String, dynamic> json) {
    if (json['PK'] != null) {
      final v = json['PK'];
      final arr0 = <String>[];
      v.forEach((v) {
        arr0.add(v.toString());
      });
      PK = arr0;
    }
  }
  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    if (PK != null) {
      final v = PK;
      final arr0 = [];
      v!.forEach((v) {
        arr0.add(v);
      });
      data['PK'] = arr0;
    }
    return data;
  }
}
